﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.3
@EndOfDesignText@
Private Sub Process_Globals
	'*****ANGULAR CONSTANTS********
	Private  POT_VALUE_MAX As Int = 700 ' potentiometer reading when motor shaft is at 180 degree position.
	'You will need To fill this value according To your setup.See below....
	Private  POT_VALUE_MIN As Int = 200 ' potentiometer reading when when motor shaft is at 0 degree position.
	'You will need To fill this value according To your setup.See below....
	'To fill up the correct values, first Turn the motor shaft manually To 0 degree position.
	'Now read the potentiometer value And edit the #define POT_VALUE_MIN line with your pot reading.
	'Next manually move the motor shaft To 180 degree position,
	'read the pot value And edit #define POT_VALUE_MAX line with your pot reading.
	Private  PERM_ERROR As Double = 0.5  ' the Max permissible error in degrees. In my potentiometer, a Turn only about 2 degrees
	'on the potentiometer shaft causes any real change in the ohmic reading. You can adjust this error
	'value As required. If PERM_ERROR is very small, the shaft will keep hunting Left And Right As the
	'analogRead of the potentiometer pin keeps fluctuating slightly
	Private const MAX_ANGLE As Int = 180 ' we will allow our motor To Turn by a maximum angle of 180 degrees
	'**********************************
	Private TurnDirection As Int
	Private Sp    As Int
'	Private Raw   As UInt
	Private CW   As Byte = 0
	Private CCW  As Byte = 1
	'*********************************
	Private ENA,ENB,PWM,Pot As Pin
End Sub
'Initial Servo Pin
' EA - EnA Direction pin
' EB - EnB Direction pin
' PW - PWM pin
Public Sub Initial(EA As Byte, EB As Byte, PW As Byte)
	ENA.Initialize(EA,ENA.MODE_OUTPUT)
	ENB.Initialize(EB,ENB.MODE_OUTPUT)
	PWM.Initialize(PW,PWM.MODE_OUTPUT)
	Pot.Initialize(0, Pot.AnalogRead)
	ENA.DigitalWrite(False)
	ENB.DigitalWrite(True)
End Sub
'Set Servo Prameter
' Er   - Max permissible error in degrees
' PMin - Min potentiometer reading
' PMax - Max potentiometer reading
Public Sub Prameter(PMin As Int, PMax As Int, Er As Double)
	POT_VALUE_MIN = PMin
	POT_VALUE_MAX = PMax
	PERM_ERROR = Er
End Sub
'Set Servo Position
' Target set angle of the shaft
' Speed  % motor speed
Public Sub GoToAngle(Target As Int, Speed As Int)
	'find out the current angle of the motor shaft
	Dim  CurrentAngle As Double = MapRange(Pot.AnalogRead ,POT_VALUE_MIN,POT_VALUE_MAX,0,MAX_ANGLE)
	'First Check If we need To Turn Left Or Right.....
	If CurrentAngle < Target Then
		SetTurnDirection(CW)
	else if CurrentAngle > Target Then
		SetTurnDirection(CCW)
	End If
	SetTurnSpeed(Speed)
'	Log("1> ",CurrentAngle)
	Do While (Abs(CurrentAngle - Target) > PERM_ERROR) 'If the shaft is Not at the required value,
		Turn ' Keep on turning the shaft
		'Allow the motor To Turn a little And wait here For a moment...
		'Delay(1)  'adjust the Delay As required depending on your motor Speed
		'update the current angle of the shaft
		CurrentAngle = MapRange(Pot.AnalogRead ,POT_VALUE_MIN,POT_VALUE_MAX,0,MAX_ANGLE)
'		Log("2> ",CurrentAngle)
	Loop
	Stop  'Stop the shaft after the error is acceptable
End Sub

#Region Function 

Private Sub SetTurnDirection(Dir As Int) ' Setting turn directions on Monester
	TurnDirection = Dir
	Select TurnDirection
		Case CW  ' turning Right
			'motor moves CW
			ENA.DigitalWrite(False)
			ENB.DigitalWrite(True)
		Case CCW ' turning Left
			'motor moves CCW
			ENA.DigitalWrite(True)
			ENB.DigitalWrite(False)
	End Select
End Sub

Private Sub SetTurnSpeed(Speed As Int)
	If Speed > 100 Then
		Sp = 255
	Else If Speed <= 0 Then
		Sp = 0
	Else
		Sp = MapRange(Speed,0,100,0,255)
	End If
End Sub

Private Sub Turn
	PWM.AnalogWrite(Sp)
End Sub
     
Private Sub Stop
	PWM.AnalogWrite(0)
End Sub

#End Region